/*
 * This file is generated by jOOQ.
 */
package de.jottyfan.camporganizer.db.jooq.tables;


import de.jottyfan.camporganizer.db.jooq.Keys;
import de.jottyfan.camporganizer.db.jooq.Public;
import de.jottyfan.camporganizer.db.jooq.tables.TCamp.TCampPath;
import de.jottyfan.camporganizer.db.jooq.tables.TCampprofile.TCampprofilePath;
import de.jottyfan.camporganizer.db.jooq.tables.TPerson.TPersonPath;
import de.jottyfan.camporganizer.db.jooq.tables.TProfilerole.TProfilerolePath;
import de.jottyfan.camporganizer.db.jooq.tables.records.TProfileRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes", "this-escape" })
public class TProfile extends TableImpl<TProfileRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>public.t_profile</code>
     */
    public static final TProfile T_PROFILE = new TProfile();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TProfileRecord> getRecordType() {
        return TProfileRecord.class;
    }

    /**
     * The column <code>public.t_profile.pk</code>.
     */
    public final TableField<TProfileRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>public.t_profile.forename</code>.
     */
    public final TableField<TProfileRecord, String> FORENAME = createField(DSL.name("forename"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>public.t_profile.surname</code>.
     */
    public final TableField<TProfileRecord, String> SURNAME = createField(DSL.name("surname"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>public.t_profile.username</code>.
     */
    public final TableField<TProfileRecord, String> USERNAME = createField(DSL.name("username"), SQLDataType.CLOB.nullable(false), this, "");

    /**
     * The column <code>public.t_profile.password</code>.
     */
    public final TableField<TProfileRecord, String> PASSWORD = createField(DSL.name("password"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>public.t_profile.duedate</code>.
     */
    public final TableField<TProfileRecord, LocalDateTime> DUEDATE = createField(DSL.name("duedate"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("(now() + '1 year'::interval)"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>public.t_profile.uuid</code>.
     */
    public final TableField<TProfileRecord, String> UUID = createField(DSL.name("uuid"), SQLDataType.CLOB.nullable(false), this, "");

    private TProfile(Name alias, Table<TProfileRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TProfile(Name alias, Table<TProfileRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>public.t_profile</code> table reference
     */
    public TProfile(String alias) {
        this(DSL.name(alias), T_PROFILE);
    }

    /**
     * Create an aliased <code>public.t_profile</code> table reference
     */
    public TProfile(Name alias) {
        this(alias, T_PROFILE);
    }

    /**
     * Create a <code>public.t_profile</code> table reference
     */
    public TProfile() {
        this(DSL.name("t_profile"), null);
    }

    public <O extends Record> TProfile(Table<O> path, ForeignKey<O, TProfileRecord> childPath, InverseForeignKey<O, TProfileRecord> parentPath) {
        super(path, childPath, parentPath, T_PROFILE);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TProfilePath extends TProfile implements Path<TProfileRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TProfilePath(Table<O> path, ForeignKey<O, TProfileRecord> childPath, InverseForeignKey<O, TProfileRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TProfilePath(Name alias, Table<TProfileRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TProfilePath as(String alias) {
            return new TProfilePath(DSL.name(alias), this);
        }

        @Override
        public TProfilePath as(Name alias) {
            return new TProfilePath(alias, this);
        }

        @Override
        public TProfilePath as(Table<?> alias) {
            return new TProfilePath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : Public.PUBLIC;
    }

    @Override
    public Identity<TProfileRecord, Integer> getIdentity() {
        return (Identity<TProfileRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TProfileRecord> getPrimaryKey() {
        return Keys.T_PROFILE_PKEY;
    }

    @Override
    public List<UniqueKey<TProfileRecord>> getUniqueKeys() {
        return Arrays.asList(Keys.T_PROFILE_USERNAME_KEY, Keys.T_PROFILE_UUID_KEY);
    }

    private transient TCampPath _tCamp;

    /**
     * Get the implicit to-many join path to the <code>public.t_camp</code>
     * table
     */
    public TCampPath tCamp() {
        if (_tCamp == null)
            _tCamp = new TCampPath(this, null, Keys.T_CAMP__T_CAMP_FK_PROFILE_FKEY.getInverseKey());

        return _tCamp;
    }

    private transient TCampprofilePath _tCampprofile;

    /**
     * Get the implicit to-many join path to the
     * <code>public.t_campprofile</code> table
     */
    public TCampprofilePath tCampprofile() {
        if (_tCampprofile == null)
            _tCampprofile = new TCampprofilePath(this, null, Keys.T_CAMPPROFILE__T_CAMPPROFILE_FK_PROFILE_FKEY.getInverseKey());

        return _tCampprofile;
    }

    private transient TPersonPath _tPersonFkProfileFkey;

    /**
     * Get the implicit to-many join path to the <code>public.t_person</code>
     * table, via the <code>t_person_fk_profile_fkey</code> key
     */
    public TPersonPath tPersonFkProfileFkey() {
        if (_tPersonFkProfileFkey == null)
            _tPersonFkProfileFkey = new TPersonPath(this, null, Keys.T_PERSON__T_PERSON_FK_PROFILE_FKEY.getInverseKey());

        return _tPersonFkProfileFkey;
    }

    private transient TPersonPath _tPersonFkRegistratorFkey;

    /**
     * Get the implicit to-many join path to the <code>public.t_person</code>
     * table, via the <code>t_person_fk_registrator_fkey</code> key
     */
    public TPersonPath tPersonFkRegistratorFkey() {
        if (_tPersonFkRegistratorFkey == null)
            _tPersonFkRegistratorFkey = new TPersonPath(this, null, Keys.T_PERSON__T_PERSON_FK_REGISTRATOR_FKEY.getInverseKey());

        return _tPersonFkRegistratorFkey;
    }

    private transient TProfilerolePath _tProfilerole;

    /**
     * Get the implicit to-many join path to the
     * <code>public.t_profilerole</code> table
     */
    public TProfilerolePath tProfilerole() {
        if (_tProfilerole == null)
            _tProfilerole = new TProfilerolePath(this, null, Keys.T_PROFILEROLE__T_PROFILEROLE_FK_PROFILE_FKEY.getInverseKey());

        return _tProfilerole;
    }

    @Override
    public TProfile as(String alias) {
        return new TProfile(DSL.name(alias), this);
    }

    @Override
    public TProfile as(Name alias) {
        return new TProfile(alias, this);
    }

    @Override
    public TProfile as(Table<?> alias) {
        return new TProfile(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TProfile rename(String name) {
        return new TProfile(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TProfile rename(Name name) {
        return new TProfile(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TProfile rename(Table<?> name) {
        return new TProfile(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TProfile where(Condition condition) {
        return new TProfile(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TProfile where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TProfile where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TProfile where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TProfile where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TProfile where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TProfile where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TProfile where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TProfile whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TProfile whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
