/*
 * This file is generated by jOOQ.
 */
package de.jottyfan.camporganizer.db.jooq.tables;


import de.jottyfan.camporganizer.db.jooq.Public;
import de.jottyfan.camporganizer.db.jooq.enums.EnumDocument;
import de.jottyfan.camporganizer.db.jooq.enums.EnumFiletype;
import de.jottyfan.camporganizer.db.jooq.tables.records.VDocumentRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes", "this-escape" })
public class VDocument extends TableImpl<VDocumentRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>public.v_document</code>
     */
    public static final VDocument V_DOCUMENT = new VDocument();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VDocumentRecord> getRecordType() {
        return VDocumentRecord.class;
    }

    /**
     * The column <code>public.v_document.pk</code>.
     */
    public final TableField<VDocumentRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>public.v_document.doctype</code>.
     */
    public final TableField<VDocumentRecord, EnumDocument> DOCTYPE = createField(DSL.name("doctype"), SQLDataType.VARCHAR.asEnumDataType(EnumDocument.class), this, "");

    /**
     * The column <code>public.v_document.name</code>.
     */
    public final TableField<VDocumentRecord, String> NAME = createField(DSL.name("name"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>public.v_document.document</code>.
     */
    public final TableField<VDocumentRecord, String> DOCUMENT = createField(DSL.name("document"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>public.v_document.filetype</code>.
     */
    public final TableField<VDocumentRecord, EnumFiletype> FILETYPE = createField(DSL.name("filetype"), SQLDataType.VARCHAR.asEnumDataType(EnumFiletype.class), this, "");

    /**
     * The column <code>public.v_document.roles</code>.
     */
    public final TableField<VDocumentRecord, String> ROLES = createField(DSL.name("roles"), SQLDataType.CLOB, this, "");

    private VDocument(Name alias, Table<VDocumentRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VDocument(Name alias, Table<VDocumentRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        CREATE VIEW "v_document" AS  SELECT d.pk,
          d.doctype,
          d.name,
          d.document,
          d.filetype,
          string_agg((r.camprole)::text, ','::text) AS roles
         FROM (t_document d
           LEFT JOIN t_documentrole r ON ((r.fk_document = d.pk)))
        GROUP BY d.pk, d.doctype, d.name, d.document, d.filetype;
        """), where);
    }

    /**
     * Create an aliased <code>public.v_document</code> table reference
     */
    public VDocument(String alias) {
        this(DSL.name(alias), V_DOCUMENT);
    }

    /**
     * Create an aliased <code>public.v_document</code> table reference
     */
    public VDocument(Name alias) {
        this(alias, V_DOCUMENT);
    }

    /**
     * Create a <code>public.v_document</code> table reference
     */
    public VDocument() {
        this(DSL.name("v_document"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : Public.PUBLIC;
    }

    @Override
    public VDocument as(String alias) {
        return new VDocument(DSL.name(alias), this);
    }

    @Override
    public VDocument as(Name alias) {
        return new VDocument(alias, this);
    }

    @Override
    public VDocument as(Table<?> alias) {
        return new VDocument(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VDocument rename(String name) {
        return new VDocument(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VDocument rename(Name name) {
        return new VDocument(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VDocument rename(Table<?> name) {
        return new VDocument(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDocument where(Condition condition) {
        return new VDocument(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDocument where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDocument where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDocument where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDocument where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDocument where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDocument where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDocument where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDocument whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDocument whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
