/*
 * This file is generated by jOOQ.
 */
package de.jottyfan.camporganizer.db.jooq.tables;


import de.jottyfan.camporganizer.db.jooq.Public;
import de.jottyfan.camporganizer.db.jooq.enums.EnumSex;
import de.jottyfan.camporganizer.db.jooq.tables.records.VFeederRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;
import org.jooq.types.YearToSecond;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes", "this-escape" })
public class VFeeder extends TableImpl<VFeederRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>public.v_feeder</code>
     */
    public static final VFeeder V_FEEDER = new VFeeder();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VFeederRecord> getRecordType() {
        return VFeederRecord.class;
    }

    /**
     * The column <code>public.v_feeder.forename</code>.
     */
    public final TableField<VFeederRecord, String> FORENAME = createField(DSL.name("forename"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>public.v_feeder.surname</code>.
     */
    public final TableField<VFeederRecord, String> SURNAME = createField(DSL.name("surname"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>public.v_feeder.street</code>.
     */
    public final TableField<VFeederRecord, String> STREET = createField(DSL.name("street"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>public.v_feeder.zip</code>.
     */
    public final TableField<VFeederRecord, String> ZIP = createField(DSL.name("zip"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>public.v_feeder.city</code>.
     */
    public final TableField<VFeederRecord, String> CITY = createField(DSL.name("city"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>public.v_feeder.phone</code>.
     */
    public final TableField<VFeederRecord, String> PHONE = createField(DSL.name("phone"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>public.v_feeder.age</code>.
     */
    public final TableField<VFeederRecord, YearToSecond> AGE = createField(DSL.name("age"), SQLDataType.INTERVAL, this, "");

    /**
     * The column <code>public.v_feeder.email</code>.
     */
    public final TableField<VFeederRecord, String> EMAIL = createField(DSL.name("email"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>public.v_feeder.sex</code>.
     */
    public final TableField<VFeederRecord, EnumSex> SEX = createField(DSL.name("sex"), SQLDataType.VARCHAR.asEnumDataType(EnumSex.class), this, "");

    /**
     * The column <code>public.v_feeder.name</code>.
     */
    public final TableField<VFeederRecord, String> NAME = createField(DSL.name("name"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>public.v_feeder.year</code>.
     */
    public final TableField<VFeederRecord, Double> YEAR = createField(DSL.name("year"), SQLDataType.DOUBLE, this, "");

    private VFeeder(Name alias, Table<VFeederRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VFeeder(Name alias, Table<VFeederRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        CREATE VIEW "v_feeder" AS  SELECT t_person.forename,
          t_person.surname,
          t_person.street,
          t_person.zip,
          t_person.city,
          t_person.phone,
          age(c.arrive, (t_person.birthdate)::timestamp without time zone) AS age,
          t_person.email,
          t_person.sex,
          c.name,
          date_part('year'::text, c.arrive) AS year
         FROM (t_person
           LEFT JOIN t_camp c ON ((c.pk = t_person.fk_camp)))
        WHERE (t_person.camprole = 'feeder'::enum_camprole);
        """), where);
    }

    /**
     * Create an aliased <code>public.v_feeder</code> table reference
     */
    public VFeeder(String alias) {
        this(DSL.name(alias), V_FEEDER);
    }

    /**
     * Create an aliased <code>public.v_feeder</code> table reference
     */
    public VFeeder(Name alias) {
        this(alias, V_FEEDER);
    }

    /**
     * Create a <code>public.v_feeder</code> table reference
     */
    public VFeeder() {
        this(DSL.name("v_feeder"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : Public.PUBLIC;
    }

    @Override
    public VFeeder as(String alias) {
        return new VFeeder(DSL.name(alias), this);
    }

    @Override
    public VFeeder as(Name alias) {
        return new VFeeder(alias, this);
    }

    @Override
    public VFeeder as(Table<?> alias) {
        return new VFeeder(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VFeeder rename(String name) {
        return new VFeeder(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VFeeder rename(Name name) {
        return new VFeeder(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VFeeder rename(Table<?> name) {
        return new VFeeder(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VFeeder where(Condition condition) {
        return new VFeeder(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VFeeder where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VFeeder where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VFeeder where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VFeeder where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VFeeder where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VFeeder where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VFeeder where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VFeeder whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VFeeder whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
