/*
 * This file is generated by jOOQ.
 */
package de.jottyfan.camporganizer.db.jooq.tables;


import de.jottyfan.camporganizer.db.jooq.Public;
import de.jottyfan.camporganizer.db.jooq.enums.EnumRole;
import de.jottyfan.camporganizer.db.jooq.tables.records.VProfileRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes", "this-escape" })
public class VProfile extends TableImpl<VProfileRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>public.v_profile</code>
     */
    public static final VProfile V_PROFILE = new VProfile();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VProfileRecord> getRecordType() {
        return VProfileRecord.class;
    }

    /**
     * The column <code>public.v_profile.pk</code>.
     */
    public final TableField<VProfileRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>public.v_profile.forename</code>.
     */
    public final TableField<VProfileRecord, String> FORENAME = createField(DSL.name("forename"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>public.v_profile.surname</code>.
     */
    public final TableField<VProfileRecord, String> SURNAME = createField(DSL.name("surname"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>public.v_profile.username</code>.
     */
    public final TableField<VProfileRecord, String> USERNAME = createField(DSL.name("username"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>public.v_profile.password</code>.
     */
    public final TableField<VProfileRecord, String> PASSWORD = createField(DSL.name("password"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>public.v_profile.uuid</code>.
     */
    public final TableField<VProfileRecord, String> UUID = createField(DSL.name("uuid"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>public.v_profile.roles</code>.
     */
    public final TableField<VProfileRecord, EnumRole[]> ROLES = createField(DSL.name("roles"), SQLDataType.VARCHAR.asEnumDataType(EnumRole.class).array(), this, "");

    private VProfile(Name alias, Table<VProfileRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VProfile(Name alias, Table<VProfileRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        CREATE VIEW "v_profile" AS  SELECT t_profile.pk,
          t_profile.forename,
          t_profile.surname,
          t_profile.username,
          t_profile.password,
          t_profile.uuid,
          array_agg(t_profilerole.role) AS roles
         FROM (t_profile
           LEFT JOIN t_profilerole ON ((t_profilerole.fk_profile = t_profile.pk)))
        WHERE (t_profile.duedate > now())
        GROUP BY t_profile.pk, t_profile.forename, t_profile.surname, t_profile.username, t_profile.password;
        """), where);
    }

    /**
     * Create an aliased <code>public.v_profile</code> table reference
     */
    public VProfile(String alias) {
        this(DSL.name(alias), V_PROFILE);
    }

    /**
     * Create an aliased <code>public.v_profile</code> table reference
     */
    public VProfile(Name alias) {
        this(alias, V_PROFILE);
    }

    /**
     * Create a <code>public.v_profile</code> table reference
     */
    public VProfile() {
        this(DSL.name("v_profile"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : Public.PUBLIC;
    }

    @Override
    public VProfile as(String alias) {
        return new VProfile(DSL.name(alias), this);
    }

    @Override
    public VProfile as(Name alias) {
        return new VProfile(alias, this);
    }

    @Override
    public VProfile as(Table<?> alias) {
        return new VProfile(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VProfile rename(String name) {
        return new VProfile(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VProfile rename(Name name) {
        return new VProfile(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VProfile rename(Table<?> name) {
        return new VProfile(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VProfile where(Condition condition) {
        return new VProfile(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VProfile where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VProfile where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VProfile where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VProfile where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VProfile where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VProfile where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VProfile where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VProfile whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VProfile whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
