/*
 * This file is generated by jOOQ.
 */
package de.jottyfan.camporganizer.db.jooq.tables;


import de.jottyfan.camporganizer.db.jooq.Public;
import de.jottyfan.camporganizer.db.jooq.enums.EnumCamprole;
import de.jottyfan.camporganizer.db.jooq.tables.records.VRegistrationRecord;

import java.time.LocalDate;
import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes", "this-escape" })
public class VRegistration extends TableImpl<VRegistrationRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>public.v_registration</code>
     */
    public static final VRegistration V_REGISTRATION = new VRegistration();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VRegistrationRecord> getRecordType() {
        return VRegistrationRecord.class;
    }

    /**
     * The column <code>public.v_registration.pk</code>.
     */
    public final TableField<VRegistrationRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>public.v_registration.forename</code>.
     */
    public final TableField<VRegistrationRecord, String> FORENAME = createField(DSL.name("forename"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>public.v_registration.surname</code>.
     */
    public final TableField<VRegistrationRecord, String> SURNAME = createField(DSL.name("surname"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>public.v_registration.street</code>.
     */
    public final TableField<VRegistrationRecord, String> STREET = createField(DSL.name("street"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>public.v_registration.zip</code>.
     */
    public final TableField<VRegistrationRecord, String> ZIP = createField(DSL.name("zip"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>public.v_registration.city</code>.
     */
    public final TableField<VRegistrationRecord, String> CITY = createField(DSL.name("city"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>public.v_registration.phone</code>.
     */
    public final TableField<VRegistrationRecord, String> PHONE = createField(DSL.name("phone"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>public.v_registration.birthdate</code>.
     */
    public final TableField<VRegistrationRecord, LocalDate> BIRTHDATE = createField(DSL.name("birthdate"), SQLDataType.LOCALDATE, this, "");

    /**
     * The column <code>public.v_registration.camprole</code>.
     */
    public final TableField<VRegistrationRecord, EnumCamprole> CAMPROLE = createField(DSL.name("camprole"), SQLDataType.VARCHAR.asEnumDataType(EnumCamprole.class), this, "");

    /**
     * The column <code>public.v_registration.email</code>.
     */
    public final TableField<VRegistrationRecord, String> EMAIL = createField(DSL.name("email"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>public.v_registration.campname</code>.
     */
    public final TableField<VRegistrationRecord, String> CAMPNAME = createField(DSL.name("campname"), SQLDataType.CLOB, this, "");

    private VRegistration(Name alias, Table<VRegistrationRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VRegistration(Name alias, Table<VRegistrationRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        CREATE VIEW "v_registration" AS  SELECT p.pk,
         p.forename,
         p.surname,
         p.street,
         p.zip,
         p.city,
         p.phone,
         p.birthdate,
         p.camprole,
         p.email,
         (c.name || date_part('isoyear'::text, c.arrive)) AS campname
        FROM (t_person p
          LEFT JOIN t_camp c ON ((c.pk = p.fk_camp)));
        """), where);
    }

    /**
     * Create an aliased <code>public.v_registration</code> table reference
     */
    public VRegistration(String alias) {
        this(DSL.name(alias), V_REGISTRATION);
    }

    /**
     * Create an aliased <code>public.v_registration</code> table reference
     */
    public VRegistration(Name alias) {
        this(alias, V_REGISTRATION);
    }

    /**
     * Create a <code>public.v_registration</code> table reference
     */
    public VRegistration() {
        this(DSL.name("v_registration"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : Public.PUBLIC;
    }

    @Override
    public VRegistration as(String alias) {
        return new VRegistration(DSL.name(alias), this);
    }

    @Override
    public VRegistration as(Name alias) {
        return new VRegistration(alias, this);
    }

    @Override
    public VRegistration as(Table<?> alias) {
        return new VRegistration(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VRegistration rename(String name) {
        return new VRegistration(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VRegistration rename(Name name) {
        return new VRegistration(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VRegistration rename(Table<?> name) {
        return new VRegistration(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VRegistration where(Condition condition) {
        return new VRegistration(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VRegistration where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VRegistration where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VRegistration where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VRegistration where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VRegistration where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VRegistration where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VRegistration where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VRegistration whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VRegistration whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
